/**
 * @name array-of-arrays-into-ast
 * @fileoverview Turns an array of arrays of data into a nested tree of plain objects
 * @version 4.0.3
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/array-of-arrays-into-ast/}
 */

"use strict";var arrayOfArraysIntoAst=(()=>{var Ft=Object.create;var P=Object.defineProperty,Nt=Object.defineProperties,Lt=Object.getOwnPropertyDescriptor,Rt=Object.getOwnPropertyDescriptors,Bt=Object.getOwnPropertyNames,xe=Object.getOwnPropertySymbols,Ut=Object.getPrototypeOf,Se=Object.prototype.hasOwnProperty,Gt=Object.prototype.propertyIsEnumerable;var we=(e,t,r)=>t in e?P(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,d=(e,t)=>{for(var r in t||(t={}))Se.call(t,r)&&we(e,r,t[r]);if(xe)for(var r of xe(t))Gt.call(t,r)&&we(e,r,t[r]);return e},R=(e,t)=>Nt(e,Rt(t));var B=(e,t)=>()=>(t||e((t={exports:{}}).exports,t),t.exports),Vt=(e,t)=>{for(var r in t)P(e,r,{get:t[r],enumerable:!0})},Te=(e,t,r,n)=>{if(t&&typeof t=="object"||typeof t=="function")for(let i of Bt(t))!Se.call(e,i)&&i!==r&&P(e,i,{get:()=>t[i],enumerable:!(n=Lt(t,i))||n.enumerable});return e};var U=(e,t,r)=>(r=e!=null?Ft(Ut(e)):{},Te(t||!e||!e.__esModule?P(r,"default",{value:e,enumerable:!0}):r,e)),Ht=e=>Te(P({},"__esModule",{value:!0}),e);var bt=B((D,E)=>{var Wt=200,Re="__lodash_hash_undefined__",Be=9007199254740991,se="[object Arguments]",Qt="[object Array]",Ue="[object Boolean]",Ge="[object Date]",Jt="[object Error]",ce="[object Function]",Ve="[object GeneratorFunction]",G="[object Map]",He="[object Number]",ue="[object Object]",Ee="[object Promise]",We="[object RegExp]",V="[object Set]",Qe="[object String]",Je="[object Symbol]",te="[object WeakMap]",qe="[object ArrayBuffer]",H="[object DataView]",Xe="[object Float32Array]",Ye="[object Float64Array]",Ze="[object Int8Array]",ze="[object Int16Array]",et="[object Int32Array]",tt="[object Uint8Array]",rt="[object Uint8ClampedArray]",nt="[object Uint16Array]",at="[object Uint32Array]",qt=/[\\^$.*+?()[\]{}|]/g,Xt=/\w*$/,Yt=/^\[object .+?Constructor\]$/,Zt=/^(?:0|[1-9]\d*)$/,y={};y[se]=y[Qt]=y[qe]=y[H]=y[Ue]=y[Ge]=y[Xe]=y[Ye]=y[Ze]=y[ze]=y[et]=y[G]=y[He]=y[ue]=y[We]=y[V]=y[Qe]=y[Je]=y[tt]=y[rt]=y[nt]=y[at]=!0;y[Jt]=y[ce]=y[te]=!1;var zt=typeof global=="object"&&global&&global.Object===Object&&global,er=typeof self=="object"&&self&&self.Object===Object&&self,j=zt||er||Function("return this")(),ot=typeof D=="object"&&D&&!D.nodeType&&D,Ce=ot&&typeof E=="object"&&E&&!E.nodeType&&E,tr=Ce&&Ce.exports===ot;function rr(e,t){return e.set(t[0],t[1]),e}function nr(e,t){return e.add(t),e}function ar(e,t){for(var r=-1,n=e?e.length:0;++r<n&&t(e[r],r,e)!==!1;);return e}function or(e,t){for(var r=-1,n=t.length,i=e.length;++r<n;)e[i+r]=t[r];return e}function it(e,t,r,n){var i=-1,a=e?e.length:0;for(n&&a&&(r=e[++i]);++i<a;)r=t(r,e[i],i,e);return r}function ir(e,t){for(var r=-1,n=Array(e);++r<e;)n[r]=t(r);return n}function sr(e,t){return e==null?void 0:e[t]}function st(e){var t=!1;if(e!=null&&typeof e.toString!="function")try{t=!!(e+"")}catch(r){}return t}function Me(e){var t=-1,r=Array(e.size);return e.forEach(function(n,i){r[++t]=[i,n]}),r}function fe(e,t){return function(r){return e(t(r))}}function $e(e){var t=-1,r=Array(e.size);return e.forEach(function(n){r[++t]=n}),r}var cr=Array.prototype,ur=Function.prototype,W=Object.prototype,ee=j["__core-js_shared__"],Ie=function(){var e=/[^.]+$/.exec(ee&&ee.keys&&ee.keys.IE_PROTO||"");return e?"Symbol(src)_1."+e:""}(),ct=ur.toString,A=W.hasOwnProperty,Q=W.toString,fr=RegExp("^"+ct.call(A).replace(qt,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),Pe=tr?j.Buffer:void 0,De=j.Symbol,Ke=j.Uint8Array,pr=fe(Object.getPrototypeOf,Object),lr=Object.create,yr=W.propertyIsEnumerable,hr=cr.splice,Fe=Object.getOwnPropertySymbols,gr=Pe?Pe.isBuffer:void 0,br=fe(Object.keys,Object),re=$(j,"DataView"),K=$(j,"Map"),ne=$(j,"Promise"),ae=$(j,"Set"),oe=$(j,"WeakMap"),F=$(Object,"create"),dr=T(re),mr=T(K),_r=T(ne),Or=T(ae),jr=T(oe),Ne=De?De.prototype:void 0,Le=Ne?Ne.valueOf:void 0;function S(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function kr(){this.__data__=F?F(null):{}}function Ar(e){return this.has(e)&&delete this.__data__[e]}function vr(e){var t=this.__data__;if(F){var r=t[e];return r===Re?void 0:r}return A.call(t,e)?t[e]:void 0}function xr(e){var t=this.__data__;return F?t[e]!==void 0:A.call(t,e)}function wr(e,t){var r=this.__data__;return r[e]=F&&t===void 0?Re:t,this}S.prototype.clear=kr;S.prototype.delete=Ar;S.prototype.get=vr;S.prototype.has=xr;S.prototype.set=wr;function k(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function Sr(){this.__data__=[]}function Tr(e){var t=this.__data__,r=J(t,e);if(r<0)return!1;var n=t.length-1;return r==n?t.pop():hr.call(t,r,1),!0}function Er(e){var t=this.__data__,r=J(t,e);return r<0?void 0:t[r][1]}function Cr(e){return J(this.__data__,e)>-1}function Mr(e,t){var r=this.__data__,n=J(r,e);return n<0?r.push([e,t]):r[n][1]=t,this}k.prototype.clear=Sr;k.prototype.delete=Tr;k.prototype.get=Er;k.prototype.has=Cr;k.prototype.set=Mr;function C(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function $r(){this.__data__={hash:new S,map:new(K||k),string:new S}}function Ir(e){return q(this,e).delete(e)}function Pr(e){return q(this,e).get(e)}function Dr(e){return q(this,e).has(e)}function Kr(e,t){return q(this,e).set(e,t),this}C.prototype.clear=$r;C.prototype.delete=Ir;C.prototype.get=Pr;C.prototype.has=Dr;C.prototype.set=Kr;function M(e){this.__data__=new k(e)}function Fr(){this.__data__=new k}function Nr(e){return this.__data__.delete(e)}function Lr(e){return this.__data__.get(e)}function Rr(e){return this.__data__.has(e)}function Br(e,t){var r=this.__data__;if(r instanceof k){var n=r.__data__;if(!K||n.length<Wt-1)return n.push([e,t]),this;r=this.__data__=new C(n)}return r.set(e,t),this}M.prototype.clear=Fr;M.prototype.delete=Nr;M.prototype.get=Lr;M.prototype.has=Rr;M.prototype.set=Br;function Ur(e,t){var r=le(e)||yn(e)?ir(e.length,String):[],n=r.length,i=!!n;for(var a in e)(t||A.call(e,a))&&!(i&&(a=="length"||un(a,n)))&&r.push(a);return r}function ut(e,t,r){var n=e[t];(!(A.call(e,t)&&yt(n,r))||r===void 0&&!(t in e))&&(e[t]=r)}function J(e,t){for(var r=e.length;r--;)if(yt(e[r][0],t))return r;return-1}function Gr(e,t){return e&&ft(t,ye(t),e)}function ie(e,t,r,n,i,a,o){var u;if(n&&(u=a?n(e,i,a,o):n(e)),u!==void 0)return u;if(!X(e))return e;var l=le(e);if(l){if(u=on(e),!t)return rn(e,u)}else{var b=w(e),_=b==ce||b==Ve;if(gn(e))return qr(e,t);if(b==ue||b==se||_&&!a){if(st(e))return a?e:{};if(u=sn(_?{}:e),!t)return nn(e,Gr(u,e))}else{if(!y[b])return a?e:{};u=cn(e,b,ie,t)}}o||(o=new M);var f=o.get(e);if(f)return f;if(o.set(e,u),!l)var s=r?an(e):ye(e);return ar(s||e,function(h,p){s&&(p=h,h=e[p]),ut(u,p,ie(h,t,r,n,p,e,o))}),u}function Vr(e){return X(e)?lr(e):{}}function Hr(e,t,r){var n=t(e);return le(e)?n:or(n,r(e))}function Wr(e){return Q.call(e)}function Qr(e){if(!X(e)||pn(e))return!1;var t=gt(e)||st(e)?fr:Yt;return t.test(T(e))}function Jr(e){if(!lt(e))return br(e);var t=[];for(var r in Object(e))A.call(e,r)&&r!="constructor"&&t.push(r);return t}function qr(e,t){if(t)return e.slice();var r=new e.constructor(e.length);return e.copy(r),r}function pe(e){var t=new e.constructor(e.byteLength);return new Ke(t).set(new Ke(e)),t}function Xr(e,t){var r=t?pe(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.byteLength)}function Yr(e,t,r){var n=t?r(Me(e),!0):Me(e);return it(n,rr,new e.constructor)}function Zr(e){var t=new e.constructor(e.source,Xt.exec(e));return t.lastIndex=e.lastIndex,t}function zr(e,t,r){var n=t?r($e(e),!0):$e(e);return it(n,nr,new e.constructor)}function en(e){return Le?Object(Le.call(e)):{}}function tn(e,t){var r=t?pe(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.length)}function rn(e,t){var r=-1,n=e.length;for(t||(t=Array(n));++r<n;)t[r]=e[r];return t}function ft(e,t,r,n){r||(r={});for(var i=-1,a=t.length;++i<a;){var o=t[i],u=n?n(r[o],e[o],o,r,e):void 0;ut(r,o,u===void 0?e[o]:u)}return r}function nn(e,t){return ft(e,pt(e),t)}function an(e){return Hr(e,ye,pt)}function q(e,t){var r=e.__data__;return fn(t)?r[typeof t=="string"?"string":"hash"]:r.map}function $(e,t){var r=sr(e,t);return Qr(r)?r:void 0}var pt=Fe?fe(Fe,Object):mn,w=Wr;(re&&w(new re(new ArrayBuffer(1)))!=H||K&&w(new K)!=G||ne&&w(ne.resolve())!=Ee||ae&&w(new ae)!=V||oe&&w(new oe)!=te)&&(w=function(e){var t=Q.call(e),r=t==ue?e.constructor:void 0,n=r?T(r):void 0;if(n)switch(n){case dr:return H;case mr:return G;case _r:return Ee;case Or:return V;case jr:return te}return t});function on(e){var t=e.length,r=e.constructor(t);return t&&typeof e[0]=="string"&&A.call(e,"index")&&(r.index=e.index,r.input=e.input),r}function sn(e){return typeof e.constructor=="function"&&!lt(e)?Vr(pr(e)):{}}function cn(e,t,r,n){var i=e.constructor;switch(t){case qe:return pe(e);case Ue:case Ge:return new i(+e);case H:return Xr(e,n);case Xe:case Ye:case Ze:case ze:case et:case tt:case rt:case nt:case at:return tn(e,n);case G:return Yr(e,n,r);case He:case Qe:return new i(e);case We:return Zr(e);case V:return zr(e,n,r);case Je:return en(e)}}function un(e,t){return t=t==null?Be:t,!!t&&(typeof e=="number"||Zt.test(e))&&e>-1&&e%1==0&&e<t}function fn(e){var t=typeof e;return t=="string"||t=="number"||t=="symbol"||t=="boolean"?e!=="__proto__":e===null}function pn(e){return!!Ie&&Ie in e}function lt(e){var t=e&&e.constructor,r=typeof t=="function"&&t.prototype||W;return e===r}function T(e){if(e!=null){try{return ct.call(e)}catch(t){}try{return e+""}catch(t){}}return""}function ln(e){return ie(e,!0,!0)}function yt(e,t){return e===t||e!==e&&t!==t}function yn(e){return hn(e)&&A.call(e,"callee")&&(!yr.call(e,"callee")||Q.call(e)==se)}var le=Array.isArray;function ht(e){return e!=null&&bn(e.length)&&!gt(e)}function hn(e){return dn(e)&&ht(e)}var gn=gr||_n;function gt(e){var t=X(e)?Q.call(e):"";return t==ce||t==Ve}function bn(e){return typeof e=="number"&&e>-1&&e%1==0&&e<=Be}function X(e){var t=typeof e;return!!e&&(t=="object"||t=="function")}function dn(e){return!!e&&typeof e=="object"}function ye(e){return ht(e)?Ur(e):Jr(e)}function mn(){return[]}function _n(){return!1}E.exports=ln});var kt=B((Ca,jt)=>{var dt=1/0,_t=9007199254740991,On=17976931348623157e292,mt=0/0,jn="[object Arguments]",kn="[object Function]",An="[object GeneratorFunction]",vn="[object String]",xn="[object Symbol]",wn=/^\s+|\s+$/g,Sn=/^[-+]0x[0-9a-f]+$/i,Tn=/^0b[01]+$/i,En=/^0o[0-7]+$/i,Cn=/^(?:0|[1-9]\d*)$/,Mn=parseInt;function $n(e,t){for(var r=-1,n=e?e.length:0,i=Array(n);++r<n;)i[r]=t(e[r],r,e);return i}function In(e,t,r,n){for(var i=e.length,a=r+(n?1:-1);n?a--:++a<i;)if(t(e[a],a,e))return a;return-1}function Pn(e,t,r){if(t!==t)return In(e,Dn,r);for(var n=r-1,i=e.length;++n<i;)if(e[n]===t)return n;return-1}function Dn(e){return e!==e}function Kn(e,t){for(var r=-1,n=Array(e);++r<e;)n[r]=t(r);return n}function Fn(e,t){return $n(t,function(r){return e[r]})}function Nn(e,t){return function(r){return e(t(r))}}var Y=Object.prototype,ge=Y.hasOwnProperty,Z=Y.toString,Ln=Y.propertyIsEnumerable,Rn=Nn(Object.keys,Object),Bn=Math.max;function Un(e,t){var r=Ot(e)||Qn(e)?Kn(e.length,String):[],n=r.length,i=!!n;for(var a in e)(t||ge.call(e,a))&&!(i&&(a=="length"||Vn(a,n)))&&r.push(a);return r}function Gn(e){if(!Hn(e))return Rn(e);var t=[];for(var r in Object(e))ge.call(e,r)&&r!="constructor"&&t.push(r);return t}function Vn(e,t){return t=t==null?_t:t,!!t&&(typeof e=="number"||Cn.test(e))&&e>-1&&e%1==0&&e<t}function Hn(e){var t=e&&e.constructor,r=typeof t=="function"&&t.prototype||Y;return e===r}function Wn(e,t,r,n){e=be(e)?e:na(e),r=r&&!n?ea(r):0;var i=e.length;return r<0&&(r=Bn(i+r,0)),Yn(e)?r<=i&&e.indexOf(t,r)>-1:!!i&&Pn(e,t,r)>-1}function Qn(e){return Jn(e)&&ge.call(e,"callee")&&(!Ln.call(e,"callee")||Z.call(e)==jn)}var Ot=Array.isArray;function be(e){return e!=null&&Xn(e.length)&&!qn(e)}function Jn(e){return de(e)&&be(e)}function qn(e){var t=he(e)?Z.call(e):"";return t==kn||t==An}function Xn(e){return typeof e=="number"&&e>-1&&e%1==0&&e<=_t}function he(e){var t=typeof e;return!!e&&(t=="object"||t=="function")}function de(e){return!!e&&typeof e=="object"}function Yn(e){return typeof e=="string"||!Ot(e)&&de(e)&&Z.call(e)==vn}function Zn(e){return typeof e=="symbol"||de(e)&&Z.call(e)==xn}function zn(e){if(!e)return e===0?e:0;if(e=ta(e),e===dt||e===-dt){var t=e<0?-1:1;return t*On}return e===e?e:0}function ea(e){var t=zn(e),r=t%1;return t===t?r?t-r:t:0}function ta(e){if(typeof e=="number")return e;if(Zn(e))return mt;if(he(e)){var t=typeof e.valueOf=="function"?e.valueOf():e;e=he(t)?t+"":t}if(typeof e!="string")return e===0?e:+e;e=e.replace(wn,"");var r=Tn.test(e);return r||En.test(e)?Mn(e.slice(2),r?2:8):Sn.test(e)?mt:+e}function ra(e){return be(e)?Un(e):Gn(e)}function na(e){return e?Fn(e,ra(e)):[]}jt.exports=Wn});var Tt=B((N,I)=>{var aa="[object Date]",oa=typeof global=="object"&&global&&global.Object===Object&&global,St=typeof N=="object"&&N&&!N.nodeType&&N,At=St&&typeof I=="object"&&I&&!I.nodeType&&I,ia=At&&At.exports===St,vt=ia&&oa.process,xt=function(){try{return vt&&vt.binding("util")}catch(e){}}(),wt=xt&&xt.isDate;function sa(e){return function(t){return e(t)}}var ca=Object.prototype,ua=ca.toString;function fa(e){return la(e)&&ua.call(e)==aa}var pa=wt?sa(wt):fa;function la(e){return!!e&&typeof e=="object"}I.exports=pa});var Ct=B(($a,Et)=>{var ya=typeof global=="object"&&global&&global.Object===Object&&global,ha=typeof self=="object"&&self&&self.Object===Object&&self,ga=ya||ha||Function("return this")(),ba=ga.isFinite;function da(e){return typeof e=="number"&&ba(e)}Et.exports=da});var Ta={};Vt(Ta,{defaults:()=>Kt,generateAst:()=>Sa,version:()=>xa});var c=U(bt(),1),It=U(kt(),1);function m(e){if(e==null||typeof e!="object")return!1;let t=Object.getPrototypeOf(e);return t!==null&&t!==Object.prototype&&Object.getPrototypeOf(t)!==null?!1:!(Symbol.iterator in e)&&!(Symbol.toStringTag in e)}var L=U(Tt(),1),Ae=U(Ct(),1);function O(e){return e==null?!1:Array.isArray(e)||typeof e=="string"?!!e.length:m(e)?!!Object.keys(e).length:typeof e=="number"}function me(e){if(typeof e!="string")throw new TypeError("Expected a string");return e.replace(/[|\\{}()[\]^$+*?.]/g,"\\$&").replace(/-/g,"\\x2d")}var _e=new Map,Mt=(e,t)=>{if(!Array.isArray(e))switch(typeof e){case"string":e=[e];break;case"undefined":e=[];break;default:throw new TypeError(`Expected '${t}' to be a string or an array, but got a type of '${typeof e}'`)}return e.filter(r=>{if(typeof r!="string"){if(typeof r>"u")return!1;throw new TypeError(`Expected '${t}' to be an array of strings, but found a type of '${typeof r}' in the array`)}return!0})},ma=(e,t)=>{t=d({caseSensitive:!1},t);let r=e+JSON.stringify(t);if(_e.has(r))return _e.get(r);let n=e[0]==="!";n&&(e=e.slice(1)),e=me(e).replace(/\\\*/g,"[\\s\\S]*");let i=new RegExp(`^${e}$`,t.caseSensitive?"":"i");return i.negated=n,_e.set(r,i),i},_a=(e,t,r,n)=>{if(e=Mt(e,"inputs"),t=Mt(t,"patterns"),t.length===0)return[];t=t.map(o=>ma(o,r));let{allPatterns:i}=r||{},a=[];for(let o of e){let u,l=[...t].fill(!1);for(let[b,_]of t.entries())if(_.test(o)&&(l[b]=!0,u=!_.negated,!u))break;if(!(u===!1||u===void 0&&t.some(b=>!b.negated)||i&&l.some((b,_)=>!b&&!t[_].negated))&&(a.push(o),n))break}return a};function z(e,t,r){return _a(e,t,r,!0).length>0}var Oa={arrayVsArrayAllMustBeFound:"any",caseSensitive:!0};function Oe(e,t,r){if(!e.length||!t.length)return!1;let n=d(d({},Oa),r),i=typeof e=="string"?[e]:Array.from(e);return typeof t=="string"?i.some(a=>z(a,t,{caseSensitive:n.caseSensitive})):n.arrayVsArrayAllMustBeFound==="any"?t.some(a=>i.some(o=>z(o,a,{caseSensitive:n.caseSensitive}))):t.every(a=>i.some(o=>z(o,a,{caseSensitive:n.caseSensitive})))}function je(e){return typeof e=="string"}function ja(e){return typeof e=="number"}function ke(e){return typeof e=="boolean"}var v=Array.isArray;function $t(e){return!!e&&e.some(t=>typeof t=="string")}function ka(e,t){return Object.keys(e).length===0||Object.keys(t).length===0||Object.keys(e).every(r=>Object.keys(t).includes(r))||Object.keys(t).every(r=>Object.keys(e).includes(r))}function g(e){return e===null?"null":(0,L.default)(e)?"date":m(e)?"object":v(e)?"array":typeof e}var Aa={cb:null,mergeObjectsOnlyWhenKeysetMatches:!0,ignoreKeys:[],hardMergeKeys:[],hardArrayConcatKeys:[],mergeArraysContainingStringsToBeEmpty:!1,oneToManyArrayObjectMerge:!1,hardMergeEverything:!1,hardArrayConcat:!1,ignoreEverything:!1,concatInsteadOfMerging:!0,dedupeStringsInArrayValues:!1,mergeBoolsUsingOrNotAnd:!0,useNullAsExplicitFalse:!1};function x(e,t,r,n){var _;let i;if(n.useNullAsExplicitFalse&&(t===null||r===null))return typeof n.cb=="function"?n.cb(t,r,null,{path:e.path,key:e.key,type:e.type}):null;let a=v(t)||m(t)?(0,c.default)(t):t,o=v(r)||m(r)?(0,c.default)(r):r,u;n.ignoreEverything?u=a:n.hardMergeEverything&&(u=o);let l=n.hardMergeEverything||n.ignoreEverything;if(v(a))if(O(a))if(v(o)&&O(o)){if(n.mergeArraysContainingStringsToBeEmpty&&($t(a)||$t(o))){let s=l?u:[];return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:i,key:e.key,type:e.type}):s}if(n.hardArrayConcat){let s=l?u:a.concat(o);return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:i,key:e.key,type:e.type}):s}let f=[];for(let s=0,h=Math.max(a.length,o.length);s<h;s++)i=(_=e.path)!=null&&_.length?`${e.path}.${s}`:`${s}`,m(a[s])&&m(o[s])&&(n.mergeObjectsOnlyWhenKeysetMatches&&ka(a[s],o[s])||!n.mergeObjectsOnlyWhenKeysetMatches)?f.push(x({path:i,key:e.key,type:[g(a),g(o)]},a[s],o[s],n)):n.oneToManyArrayObjectMerge&&(a.length===1||o.length===1)?f.push(a.length===1?x({path:i,key:e.key,type:[g(a),g(o)]},a[0],o[s],n):x({path:i,key:e.key,type:[g(a),g(o)]},a[s],o[0],n)):n.concatInsteadOfMerging?(s<a.length&&f.push(a[s]),s<o.length&&f.push(o[s])):(s<a.length&&f.push(a[s]),s<o.length&&!(0,It.default)(a,o[s])&&f.push(o[s]));n.dedupeStringsInArrayValues&&f.every(s=>je(s))&&(f=[...new Set(f)].sort()),a=(0,c.default)(f)}else{let f=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:i,key:e.key,type:e.type}):f}else{if(O(o)){let s=l?u:o;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:i,key:e.key,type:e.type}):s}let f=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:i,key:e.key,type:e.type}):f}else if(m(a)){if(O(a)){if(v(o)){if(O(o)){let p=l?u:o;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),p,{path:i,key:e.key,type:e.type}):p}let h=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),h,{path:i,key:e.key,type:e.type}):h}if(m(o)){Object.keys(o).forEach(p=>{var ve;i=(ve=e.path)!=null&&ve.length?`${e.path}.${p}`:`${p}`,a.hasOwnProperty(p)?Oe(p,n.ignoreKeys)?a[p]=x({path:i,key:p,type:[g(a),g(o)]},a[p],o[p],R(d({},n),{ignoreEverything:!0})):Oe(p,n.hardMergeKeys)?a[p]=x({path:i,key:p,type:[g(a),g(o)]},a[p],o[p],R(d({},n),{hardMergeEverything:!0})):Oe(p,n.hardArrayConcatKeys)?a[p]=x({path:i,key:p,type:[g(a),g(o)]},a[p],o[p],R(d({},n),{hardArrayConcat:!0})):a[p]=x({path:i,key:p,type:[g(a[p]),g(o[p])]},a[p],o[p],n):a[p]=o[p]});let h=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),h,{path:e.path,key:e.key,type:e.type}):a}let s=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}if(v(o)||m(o)||O(o)){let s=l?u:o;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else if((0,L.default)(a)){if((0,Ae.default)(+a)){if((0,L.default)(o)){if((0,Ae.default)(+o)){let p=l?u:a>o?a:o;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),p,{path:e.path,key:e.key,type:e.type}):p}let h=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),h,{path:e.path,key:e.key,type:e.type}):h}let s=l?u:o||a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}if((0,L.default)(o)){let s=l?u:o;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?u:o;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else if(je(a)){if(O(a)){if((v(o)||m(o)||je(o))&&O(o)){let h=l?u:o;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),h,{path:e.path,key:e.key,type:e.type}):h}let s=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}if(o!=null&&!ke(o)){let s=l?u:o;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else if(ja(a)){if(O(o)){let s=l?u:o;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else if(ke(a)){if(ke(o)){if(n.mergeBoolsUsingOrNotAnd){let h=l?u:a||o;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),h,{path:e.path,key:e.key,type:e.type}):h}let s=l?u:a&&o;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}if(o!=null){let s=l?u:o;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else if(a===null){if(o!=null){let s=l?u:o;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else{let f=l?u:o;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}let b=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),b,{path:e.path,key:e.key,type:e.type}):b}function Pt(e,t,r){var i,a;if(!arguments.length)throw new TypeError("object-merge-advanced/mergeAdvanced(): [THROW_ID_01] Both inputs are missing");let n=d(d({},Aa),r);return typeof n.ignoreKeys=="string"&&(n.ignoreKeys=[n.ignoreKeys]),typeof n.hardMergeKeys=="string"&&(n.hardMergeKeys=[n.hardMergeKeys]),(i=n==null?void 0:n.hardMergeKeys)!=null&&i.includes("*")&&(n.hardMergeEverything=!0),(a=n==null?void 0:n.ignoreKeys)!=null&&a.includes("*")&&(n.ignoreEverything=!0),x({key:null,path:"",type:[g(e),g(t)]},e,t,n)}var Dt="4.0.3";var xa=Dt,Kt={dedupe:!0};function wa(e){return Object.keys(e).sort().reduce((t,r)=>(t[r]=e[r],t),{})}function Sa(e,t){if(Array.isArray(e)){if(e.length===0)return{}}else throw new Error(`array-of-arrays-into-ast: [THROW_ID_01] inputArr must be array. Currently it's of a type ${typeof e} equal to:
${JSON.stringify(e,null,4)}`);let r=d(d({},Kt),t),n={};return e.forEach(i=>{let a=null;for(let o=i.length;o--;)a={[i[o]]:[a]};n=Pt(n,a,{concatInsteadOfMerging:!r.dedupe})}),wa(n)}return Ht(Ta);})();
/**
 * @name codsen-utils
 * @fileoverview Various utility functions
 * @version 1.0.1
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/codsen-utils/}
 */
/**
 * @name util-nonempty
 * @fileoverview Is the input (plain object, array, string or whatever) not empty?
 * @version 5.0.3
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/util-nonempty/}
 */
/**
 * @name object-merge-advanced
 * @fileoverview Deeply merge JSON-like data structures
 * @version 14.0.3
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/object-merge-advanced/}
 */
